package Extensions;

import Services.*;
import RunLoop.*;
import Conditions.*;
import Actions.*;
import Expressions.*;
import Banks.CImage;
import Objects.*;
import Runtime.MMFRuntime;
import Runtime.SurfaceView;
import Services.CBinaryFile;
import Services.CServices;
import Application.CRunApp;
import OI.*;
import Sprites.CSprite;
import Sprites.CMask;
import android.opengl.GLES20;
import OpenGL.GLRenderer;
import OpenGL.ITexture;
import android.graphics.*;
import android.opengl.GLUtils;
import android.os.Environment;
import android.graphics.Bitmap.CompressFormat;
import java.io.*;
import java.net.*;
import java.util.*;
import java.nio.*;

public class CRunActiveImageCanvas extends CRunExtension{
	public boolean change = false;
	// -------------------------------------------------------------------------
	class CRenderTexture extends CImage {
        public CRenderTexture(Bitmap texBitmap ){
            allocNative2 ((MMFRuntime.inst.app.hdr2Options & CRunApp.AH2OPT_ANTIALIASED) != 0,
                    (short) -1, CServices.getBitmapPixels (texBitmap), 0, 0, 0, 0, texBitmap.getWidth(), texBitmap.getHeight(), SurfaceView.ES);
        }
        @Override
        public void onDestroy ()  {
        }
    }
    public Bitmap psf = null;
    public Canvas psf_canvas = null;
    public CMask pColMask = null;
    private CRenderTexture psf_hwa = null;
    
    public int ret_x = 0;
    public int ret_y = 0;
    public int ret_col = 0;
    public int ret_alpha = 0;
    // -------------------------------------------------------------------------
	private CValue expRet;
	public CRunActiveImageCanvas(){
		expRet = new CValue(0);
	}
    @Override public int getNumberOfConditions(){
        return 1;
    }
    @Override
    public boolean createRunObject(CBinaryFile file, CCreateObjectInfo cob, int version){
		ho.hoX = cob.cobX; ho.hoY = cob.cobY;
		ho.roc.rcScaleX = 1.0f;
		ho.roc.rcScaleY = 1.0f;
		ho.hoImgWidth  = 32 ;
		ho.hoImgHeight = 32 ;
		ho.hoImgXSpot = 0;
		ho.hoImgYSpot = 0;
		ho.roc.rcAngle = 0;

        return true;
    }
    public void destroyRunObject(boolean bFast){
		if( psf != null ){
    		psf.recycle(); psf = null;
    	}
    	if( psf_hwa != null ){
    		psf_hwa.onDestroy() ; psf_hwa = null;
    	}
    	psf_canvas = null;
    }
    public int handleRunObject(){
        return 0;
    }
    public void displayRunObject(){
   		if ( psf != null && psf_hwa != null) {
			if ( change ) {
				psf_hwa.updateTextureWithBitmap( psf, false );
				change = false;
			}
		   	int x = ho.hoX - rh.rhWindowX ;
	    	int y = ho.hoY - rh.rhWindowY ;
	        
	    	GLRenderer.inst.renderScaledRotatedImage
	    	( psf_hwa , false , ho.roc.rcAngle , ho.roc.rcScaleX , ho.roc.rcScaleY,
	    			ho.hoImgXSpot , ho.hoImgYSpot,
	    			x,y,
	    			psf_hwa.getWidth() , psf_hwa.getHeight(),
	    			ho.ros.rsEffect,ho.ros.rsEffectParam);
			
		}
    	
    }
    public void reinitDisplay () {
    }
    public boolean condition(int num, CCndExtension cnd){
        switch (num) {
            case 0:// 
            	return true;
        }
        return false;
    }
    public void action(int num, CActExtension act){
        switch (num){
            case 0:// InitSize
                InitSize( act.getParamExpression(rh, 0) , act.getParamExpression(rh, 1) );
                break;
            case 1:// SetHotSpot
            	SetHotSpot( act.getParamExpression(rh, 0), act.getParamExpression(rh, 1));
            	break;
			case 2:// SetScale
				SetScaleXY( act.getParamExpFloat(rh, 0), act.getParamExpFloat(rh, 1));
				break;
			case 3:// SetAngle
				SetAngle( act.getParamExpression(rh, 0));
				break;
			case 4:// Clear
				Clear();
				break;
			case 5:// Paste
				Paste( act.getParamExpression(rh, 0) , act.getParamExpression(rh, 1) , act.getParamExpression(rh, 2) );
				break;
			case 6:// Erase
				Erase( act.getParamExpression(rh, 0) , act.getParamExpression(rh, 1) , act.getParamExpression(rh, 2) );
				break;
			case 7:// CollisionReset
				CollisionReset();
				break;
			case 8:// Loop_CheckMask
				LP_CheckMask( act.getParamExpression(rh, 0) , act.getParamExpression(rh, 1) , act.getParamExpression(rh, 2)  );
				break;
			case 9:// SaveImage
				SaveImage( act.getParamExpString(rh, 0) );
				break;
			case 10:// LoadImage
				LoadImage( act.getParamExpString(rh, 0) );
				break;
        }
    }
    public CValue expression(int num){
        switch (num){
			case 0:// getColor
				expRet.forceInt( getColor( ho.getExpParam().getInt() , ho.getExpParam().getInt() ) );
				break;
			case 1:// getAlpha
				expRet.forceInt( getAlpha( ho.getExpParam().getInt() , ho.getExpParam().getInt() ) );
				break;
			case 2:// getX_Loop_CheckMask
				expRet.forceInt( ret_x );
				break;
			case 3:// getY_Loop_CheckMask
				expRet.forceInt( ret_y );
				break;
			case 4:// getColor_Loop_CheckMask
				expRet.forceInt( ret_col );
				break;
			case 5:// getAlpha_Loop_CheckMask
				expRet.forceInt(ret_alpha);
            	break;
        }
        return expRet;
    }
    public CMask getRunObjectCollisionMask(int flags){
    	return pColMask;
    }
    public void InitSize( int w , int h ){
    	ho.hoImgWidth = w;
		ho.hoImgHeight = h;
    	if( psf != null ){
    		psf.recycle(); psf = null;
    	}
    	psf = Bitmap.createBitmap(w , h, Bitmap.Config.ARGB_8888);
    	psf_canvas = new Canvas( psf );
    	if( psf_hwa != null ){
    		psf_hwa.onDestroy() ; psf_hwa = null;
    	}
    	psf_hwa = new CRenderTexture( psf );
    }
    public void SetHotSpot( int x , int y ){
		ho.hoImgXSpot = x;
		ho.hoImgYSpot = y;
    }
    public void SetAngle( int p1 ){
		while (p1 < 0) p1 += 360;
		ho.roc.rcAngle = (int)p1 % 360;
    }
	public void SetScaleXY( float sx , float sy ){
		ho.roc.rcScaleX = sx;
		ho.roc.rcScaleY = sy;
    }
    public void Clear(){
    	if( psf != null )
	    	psf.eraseColor(Color.argb(0, 0, 0, 0));
    }
    public void Paste( int trg_fixed , int x ,int y ){
    	if( psf != null ){
    		CRun	rhPtr = ho.hoAdRunHeader;
			int trg_id = 0x0000FFFF & trg_fixed;
			if (trg_id < 0 || trg_id > rhPtr.rhMaxObjects) return ;
			CObject trg_obj =  ho.hoAdRunHeader.rhObjectList[trg_id];
			if (trg_obj == null || (trg_obj.hoCreationId << 16) != (0xFFFF0000 & trg_fixed))return ;
			x -= trg_obj.hoImgXSpot;
			y -= trg_obj.hoImgYSpot;
			CImage cImage = ho.getImageBank().getImageFromHandle( trg_obj.roc.rcImage );
			int[] mImage = cImage.getRawPixels();
			if(mImage == null) return;
			Bitmap image = Bitmap.createBitmap(cImage.getWidth(), cImage.getHeight(), cImage.getFormat());
			image.setPixels(mImage, 0, cImage.getWidth(), 0, 0, cImage.getWidth(), cImage.getHeight());
			Paint paint = new Paint();
			/*
			int ca,cr,cg,cb;
			ca = ((trg_obj.ros.rsEffectParam >> 24) & 0xff) ;
			cr = ((trg_obj.ros.rsEffectParam >> 16) & 0xff) ;
			cg = ((trg_obj.ros.rsEffectParam >> 8) & 0xff) ;
			cb = ((trg_obj.ros.rsEffectParam >> 0) & 0xff) ;
			*/
			paint.setColorFilter( new PorterDuffColorFilter( trg_obj.ros.rsEffectParam , PorterDuff.Mode.MULTIPLY ) );
			psf_canvas.drawBitmap(image , x, y, paint);
			change = true;
			image.recycle();
    	}
    }
    public void Erase( int trg_fixed , int x ,int y ){
    	if( psf != null ){
    		CRun	rhPtr = ho.hoAdRunHeader;
			int trg_id = 0x0000FFFF & trg_fixed;
			if (trg_id < 0 || trg_id > rhPtr.rhMaxObjects) return ;
			CObject trg_obj =  ho.hoAdRunHeader.rhObjectList[trg_id];
			if (trg_obj == null || (trg_obj.hoCreationId << 16) != (0xFFFF0000 & trg_fixed))return ;
			x -= trg_obj.hoImgXSpot;
			y -= trg_obj.hoImgYSpot;
			
			CImage cImage = ho.getImageBank().getImageFromHandle( trg_obj.roc.rcImage );
			int[] mImage = cImage.getRawPixels();
			if(mImage == null) return;
			//Bitmap trg_srf = Bitmap.createBitmap(cImage.getWidth(), cImage.getHeight(), cImage.getFormat());
			//trg_srf.setPixels(mImage, 0, cImage.getWidth(), 0, 0, cImage.getWidth(), cImage.getHeight());
			int col;
			int xx , yy , ch , cw , pw , ph;
			ch = cImage.getHeight();
			cw = cImage.getWidth();
			pw = psf.getWidth();
			ph = psf.getHeight();
			for (yy = 0; yy < ch; yy++) {
				for (xx = 0; xx < cw; xx++) {
					if (x + xx >= 0 && x + xx < pw &&
						y + yy >= 0 && y + yy < ph) {
						//col = trg_srf.getPixel(xx, yy);
						col = mImage[xx+(yy*cImage.getWidth())];
						if ( ((col >> 24) & 0xff) > 0x00) {
							psf.setPixel(x + xx, y + yy, 0x00);
						}
					}
				}
			}
			change = true;
			//trg_srf.recycle();
    	}
    }
    public void CollisionReset(){
    	if( pColMask != null ){
    		pColMask.finalize();
    		pColMask = null;
    	}
    	pColMask = psf_hwa.getMask(CMask.GCMF_OBSTACLE, (int)ho.roc.rcAngle, ho.roc.rcScaleX, ho.roc.rcScaleY);
    	ho.modif();
    }
    public void LP_CheckMask( int trg_fixed , int x ,int y ){
		if ( psf != null) {
			CRun	rhPtr = ho.hoAdRunHeader;
			int trg_id = 0x0000FFFF & trg_fixed;
			if (trg_id < 0 || trg_id > rhPtr.rhMaxObjects) return ;
			CObject trg_obj =  ho.hoAdRunHeader.rhObjectList[trg_id];
			if (trg_obj.hoType == COI.OBJ_SPR) {
				x -= trg_obj.hoImgXSpot;
				y -= trg_obj.hoImgYSpot;
				CImage cImage = ho.getImageBank().getImageFromHandle( trg_obj.roc.rcImage );
				int[] mImage = cImage.getRawPixels();
				if(mImage == null) return;
				int col , col2;
				int xx , yy , ch , cw , pw , ph;
				ch = cImage.getHeight();
				cw = cImage.getWidth();
				pw = psf.getWidth();
				ph = psf.getHeight();
				for ( yy = 0; yy < ch; yy++) {
					for ( xx = 0; xx < cw; xx++) {
						if (x + xx >= 0 && x + xx < pw &&
							y + yy >= 0 && y + yy < ph) {
							col = mImage[xx+(yy*cImage.getWidth())];
							
							if (((col >> 24) & 0xff) > 0x00) {
								ret_x = x + xx;
								ret_y = y + yy;
								col = psf.getPixel(x+xx, y+yy);
								//ret_col = col & 0x00ffffff;
								ret_col = (((col & 0xFF0000) >> 16) | (col & 0x00FF00) | ((col & 0x0000FF) << 16)) & 0x00ffffff ;
								if (((col >> 24) & 0xff) > 0x00) {
									ret_alpha = (col >> 24) & 0xff;
									generateEvent();
								}
							}
						}
					}
				}
				change = true;
			}
		}
    }
    public void SaveImage( String fname ){
    	try {
			File extStrageDir = Environment.getExternalStorageDirectory();
			File file = new File( extStrageDir.getAbsolutePath() + "/" + Environment.DIRECTORY_DCIM , fname );
			FileOutputStream outStream = new FileOutputStream(file);
			psf.compress(CompressFormat.PNG, 100, outStream);
			outStream.close();
			//android.util.Log.i("CRunActiveImageCanvas","SaveImage:"+file.getPath());
		}catch( Exception e ){
			android.util.Log.i("CRunActiveImageCanvas","SaveImage:"+e.toString());
		}
    }
    public void LoadImage( String fname ){
		try {
    		File extStrageDir = Environment.getExternalStorageDirectory();
			File file = new File( extStrageDir.getAbsolutePath() + "/" + Environment.DIRECTORY_DCIM , fname );
			Bitmap tmp = BitmapFactory.decodeFile(file.getPath());
			InitSize( tmp.getWidth() , tmp.getHeight() );
			psf_canvas.drawBitmap(tmp , 0, 0, null);
			change = true;
			tmp.recycle();
		
		}catch( Exception e ){
			android.util.Log.i("CRunActiveImageCanvas","LoadImage:"+e.toString());
		}
    }
    public void generateEvent(){
	    ho.generateEvent(0, 0);
    }
    
    public int getColor( int x , int y ){
    	int col = 0;
    	if( psf != null ){
    		col = psf.getPixel(x, y) & 0x00ffffff;
    		col = (col & 0xFF000000) | ((col & 0xFF0000) >> 16) | (col & 0x00FF00) | ((col & 0x0000FF) << 16);
    	}
    	return col;
    }
    public int getAlpha( int x , int y ){
    	int col = 0;
    	if( psf != null ){
    		col = ( psf.getPixel(x, y) >> 24 ) & 0xff;
    	}
    	return col;
    }
}
